﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HEAL.Attic;
namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
  [StorableType("F8A6AD96-28D9-4BEC-8392-8B7BA824B085")]
  public sealed class TreeModel : Symbol {

    private const int minimumArity = 0;
    private const int maximumArity = 0;
    public override int MinimumArity {
      get { return minimumArity; }
    }
    public override int MaximumArity {
      get { return maximumArity; }
    }
    [StorableConstructor]
    private TreeModel(StorableConstructorFlag _) : base(_) { }
    private TreeModel(TreeModel original, Cloner cloner) : base(original, cloner) {   }
    public TreeModel() : base("TreeModel", "Represents a TreeModel.") {    }
    public override ISymbolicExpressionTreeNode CreateTreeNode() {
      return new TreeModelTreeNode(this); }  

    public override IDeepCloneable Clone(Cloner cloner) {
      return new TreeModel(this, cloner);
    }
  }
}

